/* tslint:disable */
/* eslint-disable */
/**
 * Coscine Web API
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import type { Configuration } from '../../configuration';
import type { AxiosPromise, AxiosInstance, RawAxiosRequestConfig } from 'axios';
import globalAxios from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, type RequestArgs, BaseAPI, RequiredError, operationServerMap } from '../../base';
// @ts-ignore
import type { ResourceTypeInformationDtoIEnumerableResponse } from '../../@coscine/model';
/**
 * ProjectResourceTypeApi - axios parameter creator
 * @export
 */
export const ProjectResourceTypeApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {string} projectId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV2ProjectsProjectIdResourceTypesOptions: async (projectId: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('apiV2ProjectsProjectIdResourceTypesOptions', 'projectId', projectId)
            const localVarPath = `/api/v2/projects/{projectId}/resource-types`
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'OPTIONS', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Retrieves the available resource types information for a specific project.
         * @param {string} projectId The Id or slug of the project.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getAvailableResourceTypesInformationForProject: async (projectId: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('getAvailableResourceTypesInformationForProject', 'projectId', projectId)
            const localVarPath = `/api/v2/projects/{projectId}/resource-types`
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * ProjectResourceTypeApi - functional programming interface
 * @export
 */
export const ProjectResourceTypeApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = ProjectResourceTypeApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {string} projectId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV2ProjectsProjectIdResourceTypesOptions(projectId: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV2ProjectsProjectIdResourceTypesOptions(projectId, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ProjectResourceTypeApi.apiV2ProjectsProjectIdResourceTypesOptions']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Retrieves the available resource types information for a specific project.
         * @param {string} projectId The Id or slug of the project.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getAvailableResourceTypesInformationForProject(projectId: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ResourceTypeInformationDtoIEnumerableResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getAvailableResourceTypesInformationForProject(projectId, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ProjectResourceTypeApi.getAvailableResourceTypesInformationForProject']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
    }
};

/**
 * ProjectResourceTypeApi - factory interface
 * @export
 */
export const ProjectResourceTypeApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = ProjectResourceTypeApiFp(configuration)
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {ProjectResourceTypeApiApiV2ProjectsProjectIdResourceTypesOptionsRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV2ProjectsProjectIdResourceTypesOptions(requestParameters: ProjectResourceTypeApiApiV2ProjectsProjectIdResourceTypesOptionsRequest, options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.apiV2ProjectsProjectIdResourceTypesOptions(requestParameters.projectId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Retrieves the available resource types information for a specific project.
         * @param {ProjectResourceTypeApiGetAvailableResourceTypesInformationForProjectRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getAvailableResourceTypesInformationForProject(requestParameters: ProjectResourceTypeApiGetAvailableResourceTypesInformationForProjectRequest, options?: RawAxiosRequestConfig): AxiosPromise<ResourceTypeInformationDtoIEnumerableResponse> {
            return localVarFp.getAvailableResourceTypesInformationForProject(requestParameters.projectId, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV2ProjectsProjectIdResourceTypesOptions operation in ProjectResourceTypeApi.
 * @export
 * @interface ProjectResourceTypeApiApiV2ProjectsProjectIdResourceTypesOptionsRequest
 */
export interface ProjectResourceTypeApiApiV2ProjectsProjectIdResourceTypesOptionsRequest {
    /**
     * 
     * @type {string}
     * @memberof ProjectResourceTypeApiApiV2ProjectsProjectIdResourceTypesOptions
     */
    readonly projectId: string
}

/**
 * Request parameters for getAvailableResourceTypesInformationForProject operation in ProjectResourceTypeApi.
 * @export
 * @interface ProjectResourceTypeApiGetAvailableResourceTypesInformationForProjectRequest
 */
export interface ProjectResourceTypeApiGetAvailableResourceTypesInformationForProjectRequest {
    /**
     * The Id or slug of the project.
     * @type {string}
     * @memberof ProjectResourceTypeApiGetAvailableResourceTypesInformationForProject
     */
    readonly projectId: string
}

/**
 * ProjectResourceTypeApi - object-oriented interface
 * @export
 * @class ProjectResourceTypeApi
 * @extends {BaseAPI}
 */
export class ProjectResourceTypeApi extends BaseAPI {
    /**
     * 
     * @summary Responds with the HTTP methods allowed for the endpoint.
     * @param {ProjectResourceTypeApiApiV2ProjectsProjectIdResourceTypesOptionsRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ProjectResourceTypeApi
     */
    public apiV2ProjectsProjectIdResourceTypesOptions(requestParameters: ProjectResourceTypeApiApiV2ProjectsProjectIdResourceTypesOptionsRequest, options?: RawAxiosRequestConfig) {
        return ProjectResourceTypeApiFp(this.configuration).apiV2ProjectsProjectIdResourceTypesOptions(requestParameters.projectId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Retrieves the available resource types information for a specific project.
     * @param {ProjectResourceTypeApiGetAvailableResourceTypesInformationForProjectRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ProjectResourceTypeApi
     */
    public getAvailableResourceTypesInformationForProject(requestParameters: ProjectResourceTypeApiGetAvailableResourceTypesInformationForProjectRequest, options?: RawAxiosRequestConfig) {
        return ProjectResourceTypeApiFp(this.configuration).getAvailableResourceTypesInformationForProject(requestParameters.projectId, options).then((request) => request(this.axios, this.basePath));
    }
}

